﻿<%@ Page Language="C#" AutoEventWireup="true" MasterPageFile="../MasterPages/CourierPage.Master" CodeBehind="ViewTaskManager.aspx.cs" Inherits="Umbraco.Courier.UI.Pages.ViewTaskManager" %>

<%@ Import Namespace="Umbraco.Courier.UI" %>
<%@ Register Namespace="umbraco.uicontrols" Assembly="controls" TagPrefix="umb" %>

<asp:Content ContentPlaceHolderID="head" runat="server">

    <script type="text/javascript">

        var detailsPage = '<%= Umbraco.Courier.UI.UIConfiguration.RevisionViewPage %>';
        var redirect = '<%= Request.QueryString["redirWhenDone"] %>';
        var revision = '<%= Request.QueryString["revision"] %>';

        var isDialog = '<%= Request.QueryString["dialog"]%>';
        var taskId = '<%= Request.QueryString["taskId"]%>';

        var latest = '';

        function showError(message) {
            jQuery("#error").html(message).show();
        }

        function updateTaskList(endpoint, parentDom, pollCallback) {

            var parentList = parentDom.find("ul");
            var show = false;

            jQuery.ajax({
                type: "POST",
                url: "ViewTaskManager.aspx/" + endpoint,
                contentType: "application/json; charset=utf-8",
                dataType: "json",


                success: function (meh) {

                    var list = "<li class='task'>";
                    var render = true;

                    jQuery(meh.d).each(function (index, el) {

                        if (index == 0) {
                            if (latest != el.UniqueId) {
                                latest = el.UniqueId;
                                render = true;
                            }
                            else
                                render = false;
                        }

                        //var html = "<li class='task " + el.TaskType + "  " + el.State + "'>";
                        var html = "<div class='taskItem taskItem_" + el.State + "'>";

                        html += "<div class='label'><h3><a href='" + (isDialog ? "#" : "viewRevisionDetails.aspx?revision=" + el.RevisionAlias) + "'>" + el.TaskType + "</a></h3><small>" + el.FriendlyName + "</small></div>";


                        if (el.Message != null)
                            html += "<div class='message'>" + el.Message + "</div>";

                        html += "<br style='clear: both'/></div>";
                        list += html;

                        show = true;
                    });
                    list += "</li>";

                    if (render) {
                        parentList.children().remove();
                        parentList.append(list);
                    }
                    if (show)
                        parentDom.show();
                    else
                        parentDom.hide();

                    //call the callback with the result data
                    if (pollCallback) {
                        pollCallback(meh);
                    }

                },
                error: function (x, t, e) {
                    var msg = "<p>Unhandled exception occurred.</p><p>Status: " + x.status + "</p><p>Message: " + x.statusText + "</p>";
                    if (x.responseText && x.responseText.length > 0 && x.responseText[0] === "{") {
                        var jsonError = JSON.parse(x.responseText);
                        msg += "<p>ExceptionType: " + jsonError.ExceptionType + "</p>";
                        msg += "<p>Message: " + jsonError.Message + "</p>";
                        msg += "<p>StackTrace: " + jsonError.StackTrace + "</p>";
                    }
                    else {
                        msg += x.responseText;
                    }
                    showError(msg);
                }

            });
        }

        jQuery(document).ready(function () {


            (function updateCurrent() {

                var parentDom = jQuery("#current");
                var parentList = parentDom.find("ul");
                var show = false;

                jQuery.ajax({
                    type: "POST",
                    url: "ViewTaskManager.aspx/GetCurrentTask",
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",


                    success: function (meh) {
                        parentList.children().remove();

                        var list = "";

                        jQuery(meh.d).each(function (index, el) {
                            if (el.TaskType != null) {
                                var html = "<li class='task " + el.TaskType + "'>";

                                html += "<div class='label'><h3><a href='viewRevisionDetails.aspx?revision=" + el.RevisionAlias + "'>" + el.TaskType + "</a></h3><small>" + el.FriendlyName + "</small></div>";
                                html += "<div class='cou-progress'><div class='bar'><span style='width: " + el.Progress + "%;'></span></div><small>" + el.State + "</small></div>";

                                if (el.Message != null)
                                    html += "<div class='message'>" + el.Message + "</div>";

                                html += "<br style='clear: both'/></li>";
                                list += html;

                                show = true;
                            }
                        });

                        parentList.append(list);

                        if (show)
                            parentDom.show();
                        else {
                            parentDom.hide();
                        }

                        //re-poll
                        if (meh.d && meh.d.length && meh.d.length > 0) {
                            setTimeout(updateCurrent, 1000);
                        }
                    },
                    error: function (x, t, e) {
                        var msg = "<p>Unhandled exception occurred.</p><p>Status: " + x.status + "</p><p>Message: " + x.statusText + "</p>";
                        if (x.responseText && x.responseText.length > 0 && x.responseText[0] === "{") {
                            var jsonError = JSON.parse(x.responseText);
                            msg += "<p>ExceptionType: " + jsonError.ExceptionType + "</p>";
                            msg += "<p>Message: " + jsonError.Message + "</p>";
                            msg += "<p>StackTrace: " + jsonError.StackTrace + "</p>";
                        }
                        else {
                            msg += x.responseText;
                        }
                        showError(msg);
                    }
                });

            })();

            var retryCount = 0;

            (function updateView() {

                if (retryCount > 10) {
                    showError("Processing cannot continue, maximum retry attempts has been exceeded");
                }
                else {
                    updateTaskList("GetQueue", jQuery("#queue"), function (result) {

                        if (result && result.d && result.d.length !== undefined) {
                            if (result.d.length > 0) {
                                //poll again if there's anything in the queue
                                setTimeout(updateView, 1000);
                            }
                            else {
                                //if there's nothing in the queue, then get remaining processed until 
                                // the task id we are looking for is in the results.
                                // NOTE: since the way this works isn't very ideal and if some other admin is trying
                                // to do this at the same time and the processed tasks are cleared, we could end up in an 
                                // infinite loop. So we'll only retry 10 times and then fail.
                                updateTaskList("GetProcessed", jQuery("#processed"), function (processedResult) {
                                    //if there is no task id to search for and there's nothing processed then there's nothing to do
                                    if (!taskId && processedResult.d && processedResult.d.length !== undefined && processedResult.d.length === 0) {
                                        //exit, do nothing really
                                    }
                                    else {
                                        var done = false;
                                        jQuery(processedResult.d).each(function (index, el) {
                                            //if the task id matches, show done message.

                                            if (!taskId || (el.TaskType != null && el.UniqueId == taskId)) {
                                                showDoneMessage(el);
                                                done = true;
                                            }
                                        });
                                        if (!done) {
                                            //try again
                                            retryCount++;
                                            setTimeout(updateView, 1000);
                                        }
                                    }
                                });
                            }
                        }
                    });

                    //show any that are processed
                    updateTaskList("GetProcessed", jQuery("#processed"));
                }

            })();

        });

        function showDoneMessage(el) {

            if (isDialog == 'true') {
                var fb = jQuery("#feedback");

                //if (!fb.is(':visible')) {
                var html = "<p>";

                fb.attr("class", "");

                if (el.State == "completed") {
                    fb.addClass("success");
                    html += "<h4>'" + el.FriendlyName + "' was completed successfully</h4>";
                }
                else {
                    fb.addClass("error");
                    html += "<h4>'" + el.FriendlyName + "'  was not completed, as it returned an error</h4>";
                }

                html += "<p><a href='#' onclick='UmbClientMgr.closeModalWindow(); return false;'>Close this window</a></p>";

                fb.html(html);
                fb.show();
                //}
            }
            else {

                if (redirect == 'true' && el.State == "completed") {
                    self.location = detailsPage + "?revision=" + revision;
                }
            }
        }


    </script>
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="body" runat="server">

    <umb:umbracopanel text="Taskmanager" runat="server" hasmenu="false" id="pagePanel">

<div class="umb-pane"> 
<div id="feedback" style="display: none"></div>

<div id="current" style="display: none;  overflow:auto; height: inherit;">
<h2 class="propertypaneTitel off">In-progress tasks</h2>
<ul class='taskmanager'></ul>
</div>

<div id="done" style="display: none;  overflow:auto; height: inherit;">
<h2 class="propertypaneTitel">No current tasks running</h2>
    <ul class='taskmanager'>
        <li>
               <p>
                    There are no current tasks running, you can close this window       
               </p>
        </li>
    </ul>
</div>


<div id="queue" style="display: none;  overflow:auto; height: inherit;">
<h2 class="propertypaneTitel">Queued tasks</h2>
<ul class='taskmanager'></ul>
</div>


<div id="processed" style="display: none; overflow:auto; height: inherit;">
<h2 class="propertypaneTitel">Recently processed tasks</h2>
<ul class='taskmanager'></ul>
</div>
</div>

</umb:umbracopanel>

    <asp:placeholder runat="server" id="dialogPanel" visible="false">

<div id="feedback" style="display: none"></div>

<div id="current" style="display: none">
<h2 class="propertypaneTitel">In-progress tasks</h2>
<ul class='taskmanager'></ul>
</div>


<div id="queue" style="display: none">
<h2 class="propertypaneTitel">Queued tasks</h2>
<ul class='taskmanager'></ul>
</div>


<div id="processed" style="display: none">
<h2 class="propertypaneTitel">Recently processed tasks</h2>
<ul class='taskmanager'></ul>
</div>
        
<div id="error" class="alert alert-block alert-error" style="display: none"></div>

</asp:placeholder>

</asp:Content>
